/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 *
 * Copyright 2015 Riccardo Scorretti, Olivier Fabregues, Sandrine Demaneche, Elisabeth Navarro.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */
package risaaligner;

import ampere.util.sorting.ListSorter;
import ampere.util.sorting.ListToSort;
import java.io.File;
import java.util.Vector;

/**
 *
 * @author olivier
 */
public class FileSorter implements ListToSort {

    Vector<File> files;
    File[] sortedFiles;
    Integer[] indexes;
    
    public FileSorter (Vector<File> files,Vector<String> fileNames) {
        this.files = files;
        indexes = new Integer[files.size()];
        for (int i=0;i<files.size();i++) {
            String fileName = fileNames.elementAt(i);
            indexes[i] = Integer.valueOf(fileName.substring(6)); 
        }
        ListSorter listSorter = new ListSorter(this);
        listSorter.sort(true);
        sortedFiles = new File[files.size()];
        for (int i=0;i<files.size();i++) {
            sortedFiles[i] = files.elementAt(listSorter.getSortedIndex(i));
        }
    }

    public File[] getSortedFiles() {
        return sortedFiles;
    }
    
    @Override
    public int getRowListCount() {
        return files.size();
    }

    @Override
    public Object getDataToSort(int noRow) {
        return indexes[noRow];
    }

    @Override
    public Class getDataClass() {
        return Integer.class;
    }

    @Override
    public boolean isAscending() {
        return true;
    }
    
}
