/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * RisaAlignerMain.java
 *
 * Created on 24 juin 2014, 16:38:39
 * 
 * 
 * Copyright 2015 Riccardo Scorretti, Olivier Fabregues, Sandrine Demaneche, Elisabeth Navarro.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */
package risaaligner;

import ampere.util.help.Help;
import java.awt.event.ActionEvent;
import risaaligner.datas.Sample;
import javax.swing.ImageIcon;
import ampere.util.icon.Icone;
import ampere.util.security.KeyController;
import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.util.prefs.Preferences;
import javax.swing.Box.Filler;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JToggleButton;


/**
 *
 * @author olivier
 */
public final class Main extends javax.swing.JFrame implements MainInterface,ActionListener {

    public static String[] parametersNames = {"HEIGHT", "WIDTH"};

    RisaAligner risaAligner;
    String[] parameters=null;
    
    JButton alignLadderButton;
    JToggleButton lockButton;
    JButton alignDatasButton;

    JToggleButton shadeButton;
    JToggleButton view0Button;
    JToggleButton view1Button;
    JToggleButton view2Button;
    Filler filler0;
    Filler filler1;
    Filler filler2;
    Filler filler3;
    Filler filler4;
    JButton exportButton;
    private String[] args;
    
    KeyController licence;
    boolean licenced;
    boolean locked;
    int state;
    Sample sample;
    Help help;


    /** Creates new form RisaAlignerMain */
    public Main(String args[]) {
        this.parameters = parameters;
        
        initComponents();
        
        /*
         * construction des boutons de la barre de menus
         */
        buildButtons();

        /*
         * icone Ampere dans le coin gauche de la fenetre
         */
        ImageIcon ampere = new Icone("ampere3").getIcon();
        setIconImage(ampere.getImage());

        /*
         * lancement du programme
         */
        startProgram();
    }

    void startProgram() {
        risaAligner = new RisaAligner(this);
        getContentPane().add(risaAligner,BorderLayout.CENTER);
        
        /*
         * chargement de la config
         * 
         */
         loadConfig();

        pack();
    }

    void buildButtons() {
        

        filler0 = new Filler(new java.awt.Dimension(20, 0), new java.awt.Dimension(20, 0), new java.awt.Dimension(20,32767));
        jMenuBar1.add(filler0);

        JPanel jPanelA = new JPanel();
        jPanelA.setLayout(new javax.swing.BoxLayout(jPanelA, javax.swing.BoxLayout.LINE_AXIS));
        jPanelA.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        lockButton = new JToggleButton();
        ImageIcon lock = new Icone("cadenas").getIcon();
        ImageIcon unlock = new Icone("cadenas2").getIcon();
        lockButton.setIcon(unlock);
        lockButton.setSelectedIcon(lock);;
        lockButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        lockButton.setEnabled(false);
        lockButton.addActionListener(this);
        lockButton.setToolTipText("lock reference");
        jPanelA.add(lockButton);

        alignLadderButton = new JButton();
        ImageIcon align = new Icone("align_ladders").getIcon();
        alignLadderButton.setIcon(align);
        alignLadderButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        alignLadderButton.setEnabled(false);
        alignLadderButton.addActionListener(this);
        alignLadderButton.setToolTipText("align ladders");
        jPanelA.add(alignLadderButton);

        jMenuBar1.add(jPanelA);
        
        filler1 = new Filler(new java.awt.Dimension(20, 0), new java.awt.Dimension(20, 0), new java.awt.Dimension(20,32767));
        jMenuBar1.add(filler1);
        
        JPanel jPanelB = new JPanel();
        jPanelB.setLayout(new javax.swing.BoxLayout(jPanelB, javax.swing.BoxLayout.LINE_AXIS));
        jPanelB.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        /*
         * construction des boutons
         */
        shadeButton = new JToggleButton();
        ImageIcon shadeVisible = new Icone("shade").getIcon();
        shadeButton.setIcon(shadeVisible);
        shadeButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        shadeButton.setEnabled(false);
        shadeButton.addActionListener(this);
        shadeButton.setToolTipText("Show shade");

        jPanelB.add(shadeButton);

        alignDatasButton = new JButton();
        ImageIcon compute = new Icone("align_datas").getIcon();
        alignDatasButton.setIcon(compute);
        alignDatasButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        alignDatasButton.setEnabled(false);
        alignDatasButton.addActionListener(this);
        alignDatasButton.setToolTipText("align datas");
        jPanelB.add(alignDatasButton);

        jMenuBar1.add(jPanelB);

        filler2 = new Filler(new java.awt.Dimension(20, 0), new java.awt.Dimension(20, 0), new java.awt.Dimension(20,32767));
        jMenuBar1.add(filler2);

        JPanel jPanelC = new JPanel();
        jPanelC.setLayout(new javax.swing.BoxLayout(jPanelC, javax.swing.BoxLayout.LINE_AXIS));
        jPanelC.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        ButtonGroup buttonGroup = new ButtonGroup();
        view0Button = new JToggleButton();
        ImageIcon viewMode0 = new Icone("wiew_noAligned").getIcon();
        view0Button.setIcon(viewMode0);
        view0Button.setMargin(new java.awt.Insets(0, 0, 0, 0));
        view0Button.setEnabled(false);
        view0Button.addActionListener(this);
        view0Button.setToolTipText("View no aligned datas");
        buttonGroup.add(view0Button);

        jPanelC.add(view0Button);
        
        view1Button = new JToggleButton();
        ImageIcon viewMode = new Icone("wiew_aligned").getIcon();
        view1Button.setIcon(viewMode);
        view1Button.setMargin(new java.awt.Insets(0, 0, 0, 0));
        view1Button.setEnabled(false);
        view1Button.addActionListener(this);
        view1Button.setToolTipText("View aligned datas");
        buttonGroup.add(view1Button);

        jPanelC.add(view1Button);

        view2Button = new JToggleButton();
        ImageIcon viewMode2 = new Icone("wiew_aligned2").getIcon();
        view2Button.setIcon(viewMode2);
        view2Button.setMargin(new java.awt.Insets(0, 0, 0, 0));
        view2Button.setEnabled(false);
        view2Button.addActionListener(this);
        view2Button.setToolTipText("View twice aligned datas");
        buttonGroup.add(view2Button);

        jPanelC.add(view2Button);
        
        jMenuBar1.add(jPanelC);

        filler3 = new Filler(new java.awt.Dimension(20, 0), new java.awt.Dimension(20, 0), new java.awt.Dimension(20,32767));
        jMenuBar1.add(filler3);

        JPanel jPanelD = new JPanel();
        jPanelD.setLayout(new javax.swing.BoxLayout(jPanelD, javax.swing.BoxLayout.LINE_AXIS));
        jPanelD.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        exportButton = new JButton();
        ImageIcon save = new Icone("export").getIcon();
        exportButton.setIcon(save);
        exportButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        exportButton.setEnabled(false);
        exportButton.addActionListener(this);
        exportButton.setToolTipText("save aligned datas");
        jPanelD.add(exportButton);

        jMenuBar1.add(jPanelD);

        filler4 = new Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        jMenuBar1.add(filler4);
    }


    private void loadConfig() {
        /*
         * lecture de la config enregistree ds la base de registre
         */
        Preferences userPrefs = Preferences.userNodeForPackage(getClass());
        if (userPrefs != null) {
            risaAligner.writeMsg("> Load user config ..."+'\n');

            String projectFileName = null;
            projectFileName = userPrefs.get("projectFile", projectFileName);
            risaAligner.loadConfig(projectFileName);
        }
        /*
         * lecture des parametres passes à l applet
         */
        for (int i=0;i<parametersNames.length;i++) {
            String parameterName = parametersNames[i];
            String parameterValue = getParameter (parameterName);
            if (parameterValue != null) {
                if (parameterName.equals("WIDTH")) {
                }
                if (parameterName.equals("HEIGHT")) {
                }
            }
        }
    }
    String getParameter(String parameterName) {
        if (parameters != null) {
            for (int i=0;i<parameters.length;i++) {
            }
        }
        return null;
    }

    public void saveConfig(String projectFilePath)  {
        if (projectFilePath != null) {
            risaAligner.writeMsg("> Save default directory :  "+projectFilePath+'\n');
            Preferences userPrefs = Preferences.userNodeForPackage(getClass());
            userPrefs.put("projectFile", projectFilePath);
        }
    }
    
    public boolean verifyLicence() {
        boolean licenceOk = false;
        licence = new KeyController();
        if (licence.verifyLicence()) {
            licenceOk = true;
        }
        else {
            licenceOk = licence.tryPassword();
        }
        return licenceOk;
    }
        
    public void reinitLicence() {
        licence.reinit();
        updateButtons(false, locked,RisaAligner.STATE_NOTHING, null);
    }
    public void setLicence() {
        boolean licenceOk = false;
        if (licence.verifyLicence()) {
            licenceOk = true;
        }

        else {
            licenceOk = licence.tryPassword();
        }
        updateButtons(licenceOk, locked,state, null);
    }
    public void showLicence() {
        String expiration = licence.getExpirationDate();
        risaAligner.writeMsg("> Expiration date : "+expiration+'\n');
    }
    public void updateButtons (boolean licenced) {
        updateButtons(licenced,locked,state,sample);
    }
    public void updateButtons (boolean locked,int state, Sample sample) {
        updateButtons(licenced,locked,state,sample);
    }
    public void updateButtons (boolean licenced,boolean locked,int state, Sample sample) {
        this.licenced = licenced;
        this.locked = locked;
        this.state = state;
        this.sample = sample;

        loadProjectMenuItem.setEnabled(false);
        saveProjectMenuItem.setEnabled(false);
        openDirectoriesMenuItem.setEnabled(false);
        closeDirectoriesMenuItem.setEnabled(false);
        openDirectoryMenuItem.setEnabled(false);
        closeDirectoryMenuItem.setEnabled(false);
        exportMenuItem.setEnabled(false);
        printMenu.setEnabled(false);
        alignLadderMenuItem.setEnabled(false);
        alignDatasMenuItem.setEnabled(false);
        
        initLicenceMenuItem.setEnabled(true);
        setLicenceMenuItem.setEnabled(true);
        showLicenceMenuItem.setEnabled(true);
        
        alignLadderButton.setEnabled(false);
        alignDatasButton.setEnabled(false);
        
        lockButton.setEnabled(false);
        shadeButton.setEnabled(false);
        exportButton.setEnabled(false);

        if (licenced) {
            if (state == RisaAligner.STATE_NOTHING) {
                loadProjectMenuItem.setEnabled(true);
                openDirectoriesMenuItem.setEnabled(true);
                openDirectoryMenuItem.setEnabled(true);
                //closeDirectoriesMenuItem.setEnabled(true);
                //closeDirectoryMenuItem.setEnabled(true);
                lockButton.setSelected(false);
            }
            else if (state == RisaAligner.STATE_SAMPLE) {
                openDirectoriesMenuItem.setEnabled(true);
                openDirectoryMenuItem.setEnabled(true);
                closeDirectoriesMenuItem.setEnabled(true);
                closeDirectoryMenuItem.setEnabled(true);
                saveProjectMenuItem.setEnabled(true);
                printMenu.setEnabled(true);
                shadeButton.setEnabled(true);
            }
            else if (state == RisaAligner.STATE_ALIGNABLE) {
                openDirectoriesMenuItem.setEnabled(true);
                openDirectoryMenuItem.setEnabled(true);
                closeDirectoriesMenuItem.setEnabled(true);
                closeDirectoryMenuItem.setEnabled(true);
                saveProjectMenuItem.setEnabled(true);
                printMenu.setEnabled(true);
                lockButton.setEnabled(true);
                shadeButton.setEnabled(true);
                alignLadderButton.setEnabled(true);
                alignLadderMenuItem.setEnabled(true);
            }
            else if (state == RisaAligner.STATE_LADDER_ALIGNED) {
                openDirectoriesMenuItem.setEnabled(true);
                openDirectoryMenuItem.setEnabled(true);
                closeDirectoriesMenuItem.setEnabled(true);
                closeDirectoryMenuItem.setEnabled(true);
                saveProjectMenuItem.setEnabled(true);
                printMenu.setEnabled(true);
                lockButton.setEnabled(true);
                shadeButton.setEnabled(true);
                if (locked){
                    alignLadderButton.setEnabled(false);
                    alignLadderMenuItem.setEnabled(false);
                }
                else {
                    alignLadderButton.setEnabled(true);
                    alignLadderMenuItem.setEnabled(true);
                }
                exportButton.setEnabled(true);
                exportMenuItem.setEnabled(true);
            }

            if (locked) lockButton.setSelected(true);
            
            if (sample == null) { 
                view0Button.setSelected(true);
                view0Button.setEnabled(false);
                view1Button.setEnabled(false);
                view2Button.setEnabled(false);
                alignDatasButton.setEnabled(false);
                alignDatasMenuItem.setEnabled(false);
            }
            else {
                if (sample.bestViewMode == RisaAligner.VIEW_SAMPLE){
                    view0Button.setSelected(true);
                }
                else if (sample.bestViewMode == RisaAligner.VIEW_LADDER_ALIGNED){
                    view1Button.setSelected(true);
                }
                else {
                    view2Button.setSelected(true);
                }

                if (sample.isDatasAligned()) {
                    alignDatasButton.setEnabled(false);
                    alignDatasMenuItem.setEnabled(false);
                    view0Button.setEnabled(true);
                    view1Button.setEnabled(true);
                    view2Button.setEnabled(true);
                }
                else if (sample.isLadderAligned()) {
                    alignDatasButton.setEnabled(true);
                    alignDatasMenuItem.setEnabled(true);
                    view0Button.setEnabled(true);
                    view1Button.setEnabled(true);
                    view2Button.setEnabled(false);
                }
                else {
                    alignDatasButton.setEnabled(false);
                    alignDatasMenuItem.setEnabled(false);
                    view0Button.setEnabled(true);
                    view1Button.setEnabled(false);
                    view2Button.setEnabled(false);
                }
            }
        }
    }

    public void quit() {
        risaAligner.quit();
        System.exit(0);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        loadProjectMenuItem = new javax.swing.JMenuItem();
        saveProjectMenuItem = new javax.swing.JMenuItem();
        jSeparator5 = new javax.swing.JPopupMenu.Separator();
        openDirectoriesMenuItem = new javax.swing.JMenuItem();
        closeDirectoriesMenuItem = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        openDirectoryMenuItem = new javax.swing.JMenuItem();
        closeDirectoryMenuItem = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JPopupMenu.Separator();
        exportMenuItem = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        printMenu = new javax.swing.JMenu();
        printLadderMenuItem = new javax.swing.JMenuItem();
        printSampleMenuItem = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JPopupMenu.Separator();
        quitmenuItem = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        alignLadderMenuItem = new javax.swing.JMenuItem();
        alignDatasMenuItem = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jSeparator6 = new javax.swing.JPopupMenu.Separator();
        initLicenceMenuItem = new javax.swing.JMenuItem();
        setLicenceMenuItem = new javax.swing.JMenuItem();
        showLicenceMenuItem = new javax.swing.JMenuItem();
        jMenu4 = new javax.swing.JMenu();
        helpMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jMenu1.setText("File");

        loadProjectMenuItem.setText("load project");
        loadProjectMenuItem.setEnabled(false);
        loadProjectMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadProjectMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(loadProjectMenuItem);

        saveProjectMenuItem.setText("save project");
        saveProjectMenuItem.setEnabled(false);
        saveProjectMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveProjectMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(saveProjectMenuItem);
        jMenu1.add(jSeparator5);

        openDirectoriesMenuItem.setText("open several arrays");
        openDirectoriesMenuItem.setEnabled(false);
        openDirectoriesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openDirectoriesMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(openDirectoriesMenuItem);

        closeDirectoriesMenuItem.setText("close all arrays");
        closeDirectoriesMenuItem.setEnabled(false);
        closeDirectoriesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeDirectoriesMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(closeDirectoriesMenuItem);
        jMenu1.add(jSeparator1);

        openDirectoryMenuItem.setText("open array");
        openDirectoryMenuItem.setEnabled(false);
        openDirectoryMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openDirectoryMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(openDirectoryMenuItem);

        closeDirectoryMenuItem.setText("close array");
        closeDirectoryMenuItem.setEnabled(false);
        closeDirectoryMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeDirectoryMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(closeDirectoryMenuItem);
        jMenu1.add(jSeparator4);

        exportMenuItem.setText("Export");
        exportMenuItem.setEnabled(false);
        exportMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(exportMenuItem);
        jMenu1.add(jSeparator2);

        printMenu.setText("print");
        printMenu.setEnabled(false);

        printLadderMenuItem.setText("ladder");
        printLadderMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                printLadderMenuItemActionPerformed(evt);
            }
        });
        printMenu.add(printLadderMenuItem);

        printSampleMenuItem.setText("sample");
        printSampleMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                printSampleMenuItemActionPerformed(evt);
            }
        });
        printMenu.add(printSampleMenuItem);

        jMenu1.add(printMenu);
        jMenu1.add(jSeparator3);

        quitmenuItem.setText("quit");
        quitmenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quitmenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(quitmenuItem);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Edit");

        alignLadderMenuItem.setText("Align ladder");
        alignLadderMenuItem.setEnabled(false);
        alignLadderMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                alignLadderMenuItemActionPerformed(evt);
            }
        });
        jMenu2.add(alignLadderMenuItem);

        alignDatasMenuItem.setText("align sample");
        alignDatasMenuItem.setEnabled(false);
        alignDatasMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                alignDatasMenuItemActionPerformed(evt);
            }
        });
        jMenu2.add(alignDatasMenuItem);

        jMenuBar1.add(jMenu2);

        jMenu3.setText("Tools");
        jMenu3.add(jSeparator6);

        initLicenceMenuItem.setText("init licence");
        initLicenceMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                initLicenceMenuItemActionPerformed(evt);
            }
        });
        jMenu3.add(initLicenceMenuItem);

        setLicenceMenuItem.setText("enter licence");
        setLicenceMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setLicenceMenuItemActionPerformed(evt);
            }
        });
        jMenu3.add(setLicenceMenuItem);

        showLicenceMenuItem.setText("expiration");
        showLicenceMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showLicenceMenuItemActionPerformed(evt);
            }
        });
        jMenu3.add(showLicenceMenuItem);

        jMenuBar1.add(jMenu3);

        jMenu4.setText("Help");

        helpMenuItem.setText("help contents");
        helpMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                helpMenuItemActionPerformed(evt);
            }
        });
        jMenu4.add(helpMenuItem);

        jMenuBar1.add(jMenu4);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void openDirectoryMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openDirectoryMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.chooseDirectory();
    }//GEN-LAST:event_openDirectoryMenuItemActionPerformed

    private void closeDirectoryMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeDirectoryMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.closeCurrentDirectory();
    }//GEN-LAST:event_closeDirectoryMenuItemActionPerformed

    private void alignLadderMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_alignLadderMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.alignLadders();
    }//GEN-LAST:event_alignLadderMenuItemActionPerformed

    private void openDirectoriesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openDirectoriesMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.chooseDirectories();
    }//GEN-LAST:event_openDirectoriesMenuItemActionPerformed

    private void exportMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.export();
    }//GEN-LAST:event_exportMenuItemActionPerformed

    private void alignDatasMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_alignDatasMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.alignDatas();
    }//GEN-LAST:event_alignDatasMenuItemActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        // TODO add your handling code here:
        risaAligner.quit();
    }//GEN-LAST:event_formWindowClosing

    private void closeDirectoriesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeDirectoriesMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.closeDirectories();
    }//GEN-LAST:event_closeDirectoriesMenuItemActionPerformed

    private void quitmenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitmenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.quit();
    }//GEN-LAST:event_quitmenuItemActionPerformed

    private void printLadderMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_printLadderMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.printLadder();
    }//GEN-LAST:event_printLadderMenuItemActionPerformed

    private void printSampleMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_printSampleMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.printSample();
    }//GEN-LAST:event_printSampleMenuItemActionPerformed

    private void loadProjectMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadProjectMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.chooseStudyFile();
        
    }//GEN-LAST:event_loadProjectMenuItemActionPerformed

    private void saveProjectMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveProjectMenuItemActionPerformed
        // TODO add your handling code here:
        risaAligner.saveStudy();
    }//GEN-LAST:event_saveProjectMenuItemActionPerformed

    private void initLicenceMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_initLicenceMenuItemActionPerformed
        // TODO add your handling code here:
        reinitLicence();
    }//GEN-LAST:event_initLicenceMenuItemActionPerformed

    private void setLicenceMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setLicenceMenuItemActionPerformed
        setLicence();
    }//GEN-LAST:event_setLicenceMenuItemActionPerformed

    private void showLicenceMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showLicenceMenuItemActionPerformed
        // TODO add your handling code here:
        showLicence();
    }//GEN-LAST:event_showLicenceMenuItemActionPerformed

    private void helpMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_helpMenuItemActionPerformed
        // TODO add your handling code here:
        if (help == null) {
            help = new Help("Help","help.html");
        }
        help.setVisible(true);
    }//GEN-LAST:event_helpMenuItemActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(final String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        /*
        try {
            
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(RisaAlignerMain.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(RisaAlignerMain.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(RisaAlignerMain.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(RisaAlignerMain.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
         * 
         */
        //</editor-fold>

        
        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                Main main = new Main(args);
                main.setVisible(true);

            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem alignDatasMenuItem;
    private javax.swing.JMenuItem alignLadderMenuItem;
    private javax.swing.JMenuItem closeDirectoriesMenuItem;
    private javax.swing.JMenuItem closeDirectoryMenuItem;
    private javax.swing.JMenuItem exportMenuItem;
    private javax.swing.JMenuItem helpMenuItem;
    private javax.swing.JMenuItem initLicenceMenuItem;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JPopupMenu.Separator jSeparator3;
    private javax.swing.JPopupMenu.Separator jSeparator4;
    private javax.swing.JPopupMenu.Separator jSeparator5;
    private javax.swing.JPopupMenu.Separator jSeparator6;
    private javax.swing.JMenuItem loadProjectMenuItem;
    private javax.swing.JMenuItem openDirectoriesMenuItem;
    private javax.swing.JMenuItem openDirectoryMenuItem;
    private javax.swing.JMenuItem printLadderMenuItem;
    private javax.swing.JMenu printMenu;
    private javax.swing.JMenuItem printSampleMenuItem;
    private javax.swing.JMenuItem quitmenuItem;
    private javax.swing.JMenuItem saveProjectMenuItem;
    private javax.swing.JMenuItem setLicenceMenuItem;
    private javax.swing.JMenuItem showLicenceMenuItem;
    // End of variables declaration//GEN-END:variables

    @Override
    public void actionPerformed(ActionEvent e) {
        Object source = e.getSource();
        if (source == alignLadderButton) {
            risaAligner.alignLadders();
        }
        else if (source == lockButton) {
            risaAligner.setLocked(lockButton.isSelected());
        }
        else if (source == alignDatasButton) {
            risaAligner.alignDatas();
        }
        else if (source == shadeButton) {
            if (shadeButton.isSelected()) {
                risaAligner.setSampleViewMode (RisaAligner.SHADE_MODE);
            }
            else {
                risaAligner.setSampleViewMode (RisaAligner.CURVES_MODE);
            }
        }
        else if (source == view0Button) {
            risaAligner.setViewMode(RisaAligner.VIEW_SAMPLE);
        }
        else if (source == view1Button) {
            risaAligner.setViewMode(RisaAligner.VIEW_LADDER_ALIGNED);
        }
        else if (source == view2Button) {
            risaAligner.setViewMode(RisaAligner.VIEW_DATAS_ALIGNED);
        }
        else if (source == exportButton) {
            risaAligner.export();
        }
    }
}
