/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * TabPanel.java
 *
 * Created on 25 août 2014, 11:58:02
 * 
 * 
 * Copyright 2015 Riccardo Scorretti, Olivier Fabregues, Sandrine Demaneche, Elisabeth Navarro.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */
package risaaligner;

import ampere.util.icon.Icone;
import javax.swing.ImageIcon;
import risaaligner.datas.Sample;

/**
 *
 * @author olivier
 */
public class TabPanel extends javax.swing.JPanel {

    Sample sample;

    String sampleName;
    
    static ImageIcon nonAlignable = new Icone("blanc_blanc_blanc").getIcon();
    static ImageIcon alignable = new Icone("vert_blanc_blanc").getIcon();
    static ImageIcon ladderAligned = new Icone("vert_vert_blanc").getIcon();
    static ImageIcon datasAligned = new Icone("vert_vert_vert").getIcon();
    static ImageIcon noLightIcon = new Icone("small_no_light").getIcon();
    static ImageIcon redLightIcon = new Icone("small_red_light").getIcon();

    
    
    /** Creates new form TabPanel */
    public TabPanel(String sampleName,Sample sample) {
        this.sampleName = sampleName;
        sample.tabPanel = this;
        initComponents();
        
        nonAlignable = new Icone("empty").getIcon();
        
        jLabel1.setIcon(nonAlignable);
        jButton1.setIcon(noLightIcon);
        jLabel2.setText(sampleName);
    }

    public void setAlignable(boolean flag) {
        if (flag) {
            jLabel1.setIcon(alignable);
        }
        else {
            jLabel1.setIcon(nonAlignable);
        }
    }
    public void setLadderAligned (boolean flag) {
        if (flag) {
            jLabel1.setIcon(ladderAligned);
        }
        else {
            jLabel1.setIcon(alignable);
        }
    }
    public void setDatasAligned (boolean flag) {
        if (flag) {
            jLabel1.setIcon(datasAligned);
        }
        else {
            jLabel1.setIcon(ladderAligned);
        }
    }
    public void setSelected (boolean selected) {
        if (selected) {
            jButton1.setIcon(redLightIcon);
        }
        else {
            jButton1.setIcon(noLightIcon);
        }
    }
    public void setRef() {
        RisaAligner.risaAligner.setSampleRef( sampleName);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();

        setMaximumSize(new java.awt.Dimension(50, 2147483647));
        setOpaque(false);
        setLayout(new java.awt.BorderLayout());

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel1.setText("    ");
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jLabel1.setIconTextGap(0);
        add(jLabel1, java.awt.BorderLayout.LINE_END);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        add(jLabel2, java.awt.BorderLayout.CENTER);

        jButton1.setText("  ");
        jButton1.setToolTipText("Set ladder as reference");
        jButton1.setAutoscrolls(true);
        jButton1.setBorder(null);
        jButton1.setBorderPainted(false);
        jButton1.setContentAreaFilled(false);
        jButton1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        jButton1.setIconTextGap(0);
        jButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButton1.setRolloverEnabled(true);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        add(jButton1, java.awt.BorderLayout.LINE_START);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        setRef();
    }//GEN-LAST:event_jButton1ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    // End of variables declaration//GEN-END:variables
}
