/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * 
 * Copyright 2015 Riccardo Scorretti, Olivier Fabregues, Sandrine Demaneche, Elisabeth Navarro.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */
package risaaligner.datas;

import ampere.util.primitives.TableElementExistException;
import java.awt.Color;
import java.io.File;
import java.util.Vector;
import risaaligner.FileSorter;

/**
 *
 * @author olivier
 */
public class SampleReader {
    
    static int NORMAL = 0;
    static int ALIGNED = 1;
    static int ALIGNED2 = 2;
    static int ALIGNED_NEGAT = 3;
    static int ALIGNED2_NEGAT = 4;
    
    boolean existNormal = false;
    boolean existAligned = false;
    boolean existAligned2 = false;
    boolean existAlignedNegat = false;
    boolean existAlign2Negat = false;
    
    File directory;
    Color[] curveColors = {Color.BLUE,Color.CYAN,Color.GREEN,Color.MAGENTA,Color.ORANGE,Color.PINK,Color.RED,Color.YELLOW};
    int colorIndice = 0;

    
    public SampleReader(File directory) {
        this.directory = directory;
        
        /*
         * recherche des types de fichiers presents
         */

        File[] files = directory.listFiles();
        if (files == null) return;
        for (int i=0;i<files.length;i++) {
            File file = files[i];
            
            String fileName = file.getName();
            if (fileName.endsWith("Ladder.csv")) {
                existNormal = true;
            }
            else if (fileName.endsWith("Ladder_aligned.csv")) {
               existAligned = true;
            }
            else if (fileName.endsWith("Ladder_aligned2.csv")) {
               existAligned2 = true;
            }
            else if (fileName.endsWith("Ladder_aligned_negat.csv")) {
               existAlignedNegat = true;
            }
            else if (fileName.endsWith("Ladder_aligned2_negat.csv")) {
               existAlign2Negat = true;
            }
        }
        
    }
    
    public boolean existNormal() {
        return existNormal;
    }
    public boolean existAligned() {
        return existAligned;
    }
    public boolean existAligned2() {
        return existAligned2;
    }
    public boolean existAlignedNegat() {
        return existAlignedNegat;
    }
    public boolean existAligned2Negat() {
        return existAlign2Negat;
    }
    
    
    public Sample getSample(int type) throws TableElementExistException {
        
        if (directory == null) return null;

        /*
         * stockage du nom de repertoire
         */
        String repName = directory.getName();
        String repPath = directory.getAbsolutePath();
        DataSet ladderDataSet=null;
        DataSet[] dataSets;
        
        /*
         * recherche des fichiers de données dans le repertoire
         */
        File ladderFile;
        Vector<File> csvFiles = new Vector<File>();
        Vector<String> csvFileNames = new Vector<String>();

        File[] files = directory.listFiles();
        if (files == null) return null;
        for (int i=0;i<files.length;i++) {
            File file = files[i];
            
            String fileName = file.getName();
            if (fileName.endsWith(".csv")) {
                //fileName = fileName.substring(0,fileName.length()-4);
                if (type == ALIGNED && fileName.endsWith("_aligned.csv")) {
                    fileName = fileName.substring(0,fileName.length()-12);
                }
                else if (type == ALIGNED2 && fileName.endsWith("_aligned2.csv")) {
                    fileName = fileName.substring(0,fileName.length()-13);
                }
                else if (type == ALIGNED_NEGAT && fileName.endsWith("_aligned_negat.csv")) {
                    fileName = fileName.substring(0,fileName.length()-18);
                }
                else if (type == ALIGNED2_NEGAT && fileName.endsWith("_aligned2_negat.csv")) {
                    fileName = fileName.substring(0,fileName.length()-19);
                }
                else if (type == NORMAL && fileName.endsWith(".csv")) {
                    fileName = fileName.substring(0,fileName.length()-4);
                }
                else {
                    continue;
                }
                
                if (fileName.endsWith("Ladder")) {
                    ladderFile = file;
                    try {
                        ladderDataSet = new DataSet(ladderFile);
                    } 
                    catch (Exception ex) {
                    }
                }

                else {
                    int index = fileName.lastIndexOf('_');
                    if (index >=0) {
                        fileName = fileName.substring(index+1,fileName.length());
                        if (fileName.startsWith("Sample") ) {
                            csvFiles.addElement(file); 
                            csvFileNames.addElement(fileName);
                        }
                    }
                }
            }
        }
        
        if (ladderDataSet == null) return null;

        
        /*
         * tri des fichiers par ordre croissant
         */
        FileSorter fileSorter = new FileSorter(csvFiles,csvFileNames);
        File[] sortedFiles = fileSorter.getSortedFiles();

        /*
         * lecture des fichiers de DataSet
         */
        Vector<DataSet> vDatasSets = new Vector<DataSet>() ;
        for (int i=0;i<sortedFiles.length;i++) {
            File file = sortedFiles[i];
            try {
                DataSet dataSet = new DataSet(file);
                dataSet.color = curveColors[colorIndice];
                colorIndice++;
                if (colorIndice>= curveColors.length)colorIndice = 0;

                vDatasSets.addElement(dataSet);
            }
            catch (Exception ex) {
                
                //RisaAligner.risaAligner.writeError("> problem when reading file "+file.getName()+'\n');
            }
        }
        
        /*
         * creation du sample
         */
        
        dataSets = new DataSet[vDatasSets.size()];
        vDatasSets.copyInto(dataSets);
        Sample sample = new Sample (repName,repPath,null,ladderDataSet,dataSets);
        


        return sample;
    }
    
}
