/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * 
 * Copyright 2015 Riccardo Scorretti, Olivier Fabregues, Sandrine Demaneche, Elisabeth Navarro.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */
package risaaligner.datas;

import ampere.graphic2d.Curve.LineSpot;
import java.awt.Color;

/**
 *
 * @author olivier
 */
public class SpotLine extends LineSpot {
    public static int NORMAL = 0;
    public static int FREE = 1;
    public static int DISABLED = 2;
    
    public static boolean VISIBLE = true;
    public static boolean INVISIBLE = false;
    
    public static Color spotColorNormal = Color.ORANGE;
    public static Color spotColorFree = Color.GREEN;
    public static Color spotColorOff = Color.RED;
  

    public int xIndex0;
    public int xIndex1;
    public int state = 0;

    public SpotLine(int index,int xIndex,int state,boolean visible) {
        super(index,xIndex,spotColorNormal,visible);
        xIndex0 = xIndex;
        this.state = state;
        if (state==NORMAL) {
            color = spotColorNormal;
        }
        else if (state==FREE) {
            color = spotColorFree;
        }
        else if (state==DISABLED) {
            color = spotColorOff;
        }
    }
    public int changeState () {
        if (state==NORMAL) {
            state=FREE;
            color = spotColorFree;
        }
        else if (state==FREE) {
            state=DISABLED;
            color = spotColorOff;
        }
        else if (state==DISABLED) {
            state=NORMAL;
            color = spotColorNormal;
        }
        return state;
    }
}
