/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * 
 * 
 * Copyright 2015 Riccardo Scorretti, Olivier Fabregues, Sandrine Demaneche, Elisabeth Navarro.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */
package risaaligner.graphic;


import ampere.graphic2d.Curve.Graphe;
import ampere.graphic2d.GMouseListener;
import ampere.graphic2d.GMouseMotionListener;
import ampere.graphic2d.GObject;
import ampere.graphic2d.GScene;
import ampere.graphic2d.GStyle;
import ampere.util.primitives.Point2d;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.text.DecimalFormat;
import java.text.NumberFormat;

/**
 *
 * @author olivier
 */
public class GuiDataSet extends Graphe implements GMouseListener,GMouseMotionListener  {
    
    //double level ;
    
    public GuiDataSet() {
 
        /*
         * configuration de la scene
         */
        setDrawingMode(GScene.DOUBLE_BUFFER);
        
        GStyle style = new GStyle(null,null,null,null,null,null);
        setSceneStyle(style);
        
        setMargins(5,15,15,5);
        setCurveBackground(Color.white);
        
        setXMargeLabel(5);

        /*
         * il n est pas conseillé de valider le rubberband car a chaque modification
         * toute la scene est retracee comme le mode XOR ne marche pas.
         * Ca sature les buffer et tout se plante !!!!!!!!!
         */
        //enableRubberbandZoom(true);
        //enableRubberbandSelection(true);


        /*
         * config de l interactivite
         */
        
        /*
         * creation et choix des formats
         */
        NumberFormat formatX = NumberFormat.getInstance();
        if (formatX instanceof DecimalFormat) {
            ((DecimalFormat)formatX).applyPattern("0.##");
        }
        NumberFormat formatY = NumberFormat.getInstance();
        if (formatY instanceof DecimalFormat) {
            ((DecimalFormat)formatY).applyPattern("0.##");
        }
        setFormatXUnits(formatX);
        setFormatYUnits(formatY);
        
        Font labelFont = new Font ("Dialog", Font.BOLD, 14);
        GStyle labelStyle = new GStyle(Color.black,Color.black,Color.BLACK,Color.RED,Color.BLACK,Color.BLUE,labelFont,Color.black);
        Font unitsFont = new Font ("Dialog", Font.BOLD, 10);
        GStyle unitsStyle = new GStyle(Color.black,Color.black,Color.RED,Color.RED,Color.RED,Color.RED,unitsFont,Color.black);
        
        setLabelStyle (labelStyle);
        setUnitsStyle (unitsStyle);
        
        GStyle cadreStyle = new GStyle(Color.black,Color.BLACK,Color.BLACK,null);
        setLineBorder(cadreStyle);

    }
        
    public void addSpots (GSpot[] gSpots) {
        for (int i=0;i<gSpots.length;i++) {
            addSpot (gSpots[i]);
        }
    }
    public void removeSpots (GSpot[] gSpots) {
        for (int i=0;i<gSpots.length;i++) {
            removeSpot (gSpots[i]);
        }
    }
    
    public void setMinMax(double xMin,double xMax,double yMin,double yMax) {
        super.setMinMax(xMin,xMax,yMin,1.1*yMax);
    }
    public void addGrid(double xMin,double xMax,double yMin,double yMax) {
        super.addGrid(xMin,xMax,yMin,1.1*yMax);
    }

    @Override
    public void mouseClicked(MouseEvent e, Point2d point, GObject gLastObject) {
    }

    @Override
    public void mousePressed(MouseEvent e, Point2d point, GObject gLastObject) {
    }

    @Override
    public void mouseReleased(MouseEvent e, Point2d point, GObject gLastObject) {
    }

    @Override
    public void mouseEntered(MouseEvent e, Point2d point, GObject gLastObject) {
    }

    @Override
    public void mouseExited(MouseEvent e, Point2d point, GObject gLastObject) {
    }

    @Override
    public void mouseMoved(MouseEvent e, Point2d point, GObject gObject) {
    }

    @Override
    public void mouseDragged(MouseEvent e,int x0,int y0, Point2d point, GObject gSelectedObject, GObject gCurrentObject) {
    }
}
